<?php
namespace Drupal\miniorange_saml_idp;

class mo_saml_visualTour {

   public static function genArray($overAllTour = 'tabTour'){
        $link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
        $exploded = explode('/', $link);
        $getPageName = end($exploded);

       $Tour_Token = \Drupal::config('miniorange_saml_idp.settings')->get('mo_saml_tourTaken_' . $getPageName);
       if($overAllTour == 'overAllTour') {
           $getPageName = 'overAllTour';
       }
       $moTourArr = array (
           'pageID' => $getPageName,
           'tourData' => mo_saml_visualTour::getTourData( $getPageName ),
           'tourTaken' => 'advance_settings' === $getPageName || 'support' === $getPageName || 'Licensing' === $getPageName? TRUE : $Tour_Token,
           'addID' => mo_saml_visualTour::addID(),
           'pageURL' => $_SERVER['REQUEST_SCHEME'] . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'],
       );

       \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('mo_saml_tourTaken_' . $getPageName, TRUE)->save();
       $moTour = json_encode($moTourArr);
       return $moTour;

    }

    public static function addID()
    {
        $idArray = array(
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(1)',
                'newID'     =>'mo_vt_idp_setup',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(2)',
                'newID'     =>'mo_vt_sp_setup',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(3)',
                'newID'     =>'mo_vt_mapping',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(4)',
                'newID'     =>'mo_vt_advance_settings',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(5)',
                'newID'     =>'mo_vt_support',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(6)',
                'newID'     =>'mo_vt_licensing',
            ),
            array(
                'selector'  =>'li.tabs__tab:nth-of-type(7)',
                'newID'     =>'mo_vt_account',
            ),
            array(
                'selector'  =>'table',
                'newID'     =>'mo_SP_url_table',
            ),
        );
        return $idArray;
    }

    public static function getTourData($pageID)
    {
        $tourData = array();
        $link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
        $exploded = explode('/', $link);
        $getPageName = end($exploded);
        $Tour_Token = \Drupal::config('miniorange_saml_idp.settings')->get('mo_saml_tourTaken_' . $getPageName);

        if($Tour_Token == 0 || $Tour_Token == FALSE)
            $tab_index = 'sp_setup';
        else $tab_index = 'idp_tab';


        $tourData['sp_setup'] = array(
            0 =>    array(
                'targetE'       =>  'mo_SP_url_table',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata URLs</h1>',
                'contentHTML'   =>  'You can manually configure your Service Provider using the information given here.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',

            ),
            1 =>    array(
                'targetE'       =>  'download_metadata_file',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata XML File</h1>',
                'contentHTML'   =>  'Provide this Metadata XML file to configure your Service Provider',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            2 =>    array(
                'targetE'       =>  'idp_metadata_url',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata URL</h1>',
                'contentHTML'   =>  'Provide this Metadata URL to configure your Service Provider',
                'ifNext'        =>  true,
                'buttonText'    =>  'Close',
                'cardSize'      =>  'medium',
                'ifskip'        =>  'hidden',
            ),
        );

        $tourData[$tab_index] = array(
            0 =>    array(
                'targetE'       =>  'mo_vt_support',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Support</h1>',
                'contentHTML'   =>  'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            1 =>    array(
                'targetE'       =>  'mo_vt_idp_setup',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Identity Provider Metadata</h1>',
                'contentHTML'   =>  'This tab provides details to configure your Service Provider.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            2 =>    array(
                'targetE'       =>  'mo_vt_sp_setup',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Service Provider Setup</h1>',
                'contentHTML'   =>  'Configure this tab using service provider information which you get from SP-Metadata XML',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            3 =>    array(
                'targetE'       =>  'mo_vt_mapping',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Attribute Mapping Tab</h1>',
                'contentHTML'   =>  'In this tab you can find NameID attribute, Custom attribute mapping and more.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            4 =>    array(
                'targetE'       =>  'mo_vt_licensing',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Upgrade Plans Tab</h1>',
                'contentHTML'   =>  'You can find premium features and can upgrade to our any of the plans.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            5 =>    array(
                'targetE'       =>  'mo_vt_account',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Register/Login <em>(Optional)</em></h1>',
                'contentHTML'   =>  'If you want to upgrade to the paid version, you need to <b>Register/Login</b> into your miniOrange account',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            6 =>    array(
                'targetE'       =>  'idp_metadata_url',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata URL</h1>',
                'contentHTML'   =>  'Provide this Metadata URL to configure your Service Provider',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            7 =>    array(
                'targetE'       =>  'download_metadata_file',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata XML File</h1>',
                'contentHTML'   =>  'Provide this Metadata XML file to configure your Service Provider',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            8 =>    array(
                'targetE'       =>  'mo_SP_url_table',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>IDP Metadata URLs</h1>',
                'contentHTML'   =>  'You can manually configure your Service Provider using the information given here.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Close',
                'cardSize'      =>  'largemedium',
                'ifskip'        =>  'hidden',

            ),
        );

        $tourData['overAllTour'] = array(
            0 =>    array(
                'targetE'       =>  'mo_vt_support',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Support</h1>',
                'contentHTML'   =>  'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            1 =>    array(
                'targetE'       =>  'mo_vt_idp_setup',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Identity Provider Metadata</h1>',
                'contentHTML'   =>  'This tab provides details to configure your Service Provider.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            2 =>    array(
                'targetE'       =>  'mo_vt_sp_setup',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Service Provider Setup</h1>',
                'contentHTML'   =>  'Configure this tab using service provider information which you get from SP-Metadata XML',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            3 =>    array(
                'targetE'       =>  'mo_vt_mapping',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Attribute Mapping Tab</h1>',
                'contentHTML'   =>  'In this tab you can find NameID attribute, Custom attribute mapping and more.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            4 =>    array(
                'targetE'       =>  'mo_vt_advance_settings',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Advance Settings Tab</h1>',
                'contentHTML'   =>  'Import/Export configurations. Add custom certificate',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            5 =>    array(
                'targetE'       =>  'mo_vt_licensing',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Upgrade Plans Tab</h1>',
                'contentHTML'   =>  'You can find premium features and can upgrade to our any of the plans.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            6 =>    array(
                'targetE'       =>  'mo_vt_account',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Register/Login <em>(Optional)</em></h1>',
                'contentHTML'   =>  'If you want to upgrade to the paid version, you need to <b>Register/Login</b> into your miniOrange account',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
        );


        $tourData['customer_setup'] = array(
            0 =>    array(
                'targetE'       =>  'mo_vt_support',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Support</h1>',
                'contentHTML'   =>  'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            1 =>    array(
                'targetE'       =>  'Register_Section',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Register/Login with miniOrange</h1>',
                'contentHTML'   =>  'Just complete the short registration with miniOrange to upgrade the module. <b>(Optional)</b>',
                'ifNext'        =>  true,
                'buttonText'    =>  'Close',
                'cardSize'      =>  'big',
                'action'        =>  '',
                'ifskip'        =>  'hidden',
            ),
        );

        $tourData['idp_setup'] = array(
            0 =>    array(
                'targetE'       =>  'edit-mo-saml-sp-setup',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Upload Your Metadata</h1>',
                'contentHTML'   =>  'If you have a <strong>metadata URL</strong> or <strong>file</strong> provided by your SP, click on the <strong>Upload SP Metadata</strong> button or you can configure the module manually.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            1 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-name',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Service Provider Name</h1>',
                'contentHTML'   =>  'Enter appropriate name for your Service Provider',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            2 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-entity-id',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>SP Entity ID/Issuer</h1>',
                'contentHTML'   =>  'You can find the EntityID in your SP-Metadata XML file enclosed in <code>entityDescriptor</code> tag having attribute as entityID.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            3 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-acs-url',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>ACS URL</h1>',
                'contentHTML'   =>  'You can find the ACS URL in SP-Metadata XML file enclosed in <code>AssertionConsumerService</code> tag having attribute as Location.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
            4 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-nameid-format',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>NameID Format</h1>',
                'contentHTML'   =>  'You can select NameID format to send in SAML response.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            5 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-relay-state',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Relay State (Optional)</h1>',
                'contentHTML'   =>  'You can give URL here, on which user will be redirected after successful SSO.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            6 =>    array(
                'targetE'       =>  'assertion_signed',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Assertion Signed</h1>',
                'contentHTML'   =>  'Select this option if you want to sign SAML Assertion',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'cardSize'      =>  'medium',
                'action'        =>  '',
            ),
            7 =>    array(
                'targetE'       =>  'mo_vt_support',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Support</h1>',
                'contentHTML'   =>  'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Close',
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
                'ifskip'        =>  'hidden',
            ),
        );


        $tourData['Mapping'] = array(
            0 =>    array(
                'targetE'       =>  'edit-miniorange-saml-idp-nameid-attr-map',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>NameID Attribute</h1>',
                'contentHTML'   =>  'This attribute value is sent in SAML Response. Users in your Service Provider will be searched (existing users) or created (new users) based on this attribute.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Close',
                'cardSize'      =>  'big',
                'action'        =>  '',
                'ifskip'        =>  'hidden',
            ),
        );

        $tourData['export_config'] = array(
            0 =>    array(
                'targetE'       =>  'Exort_Configuration',
                'pointToSide'   =>  'left',
                'titleHTML'     =>  '<h1>Export Configuration</h1>',
                'contentHTML'   =>  'Download module configuration file. This file will help you to transfer your module configurations when you change your Drupal instance',
                'ifNext'        =>  true,
                'buttonText'    =>  'End Tour',
                'cardSize'      =>  'big',
                'action'        =>  '',
            ),
        );

        return isset($tourData[$pageID]) ? $tourData[$pageID] : 0;
    }
}

/*
                            ********************************
                                    array terms :
                            ********************************
pageID              -   your Page ID, contains array of popups
0                   -   Popup/card number, goes from zero to n. For next Tab card use 'nextCard' instead of number
targetE             -   Element to target to. Has to be element ID without #. If no ID, add one. Empty For none, shows in centre of screen if empty
pointToSide         -   Direction of arrow to point to (up,down,left,right), for no arrow-keep empty (places at center keep targetE empty) //look at this fix
titleHTML           -   Title of card, can be HTML code
contentHTML         -   Content of card, can be HTML code
ifNext              -   if to show(true) Next Button or not(false), Keep False for Card Number('nextTab')
buttonText          -   Next Button Text
img                 -   image(icon) attributes ('src' should not be 'empty' with 'visible' true)
                        src     -   url of image(best for ico/transparent png) icon(https://visualpharm.com/assets/262/Comments-595b40b65ba036ed117d3e48.svg)
                        visible -   to show image or not, true or false
cardSize            -   Card has 3 difined sizes- big, medium and small. Recomended not to use image with small
nextTab             -   This is special card used if you want user to move to next tab during tour, disabled during restart tour

 */